ETSI STF525 / Internal Testing test suite This project provides an internal testing test suite and its associated Test Adapter/Codec

Public Member Functions | Protected Member Functions | List of all members
per_code< TPDU > Class Template Referenceabstract

Declare asn1c class. More...

`#include <per_code.hh>`

Inheritance diagram for per_code< TPDU >:

## Public Member Functions
virtual int | encode (const TPDU &p_message, BITSTRING &p_bitstring)=0
| Encode TITAN message into ASN.1 PER message. More...
virtual int | decode (const BITSTRING &p_bitstring, TPDU &p_message)=0
| Decode ASN.1 PER message into TITAN message. More...

## Protected Member Functions
int | _decode (const TTCN_Typedescriptor_t &ttcn, const asn_TYPE_descriptor_s &td, const BITSTRING &p_data, TPDU &msg)
int | _encode (const TTCN_Typedescriptor_t &ttcn, const asn_TYPE_descriptor_s &td, const TPDU &msg, BITSTRING &p_data)
Protected Member Functions inherited from asn1_recode_per
int | ber2per (const asn_TYPE_descriptor_s &td, TTCN_Buffer &buf)
int | per2ber (const asn_TYPE_descriptor_s &td, TTCN_Buffer &buf)
int | recode (const asn_TYPE_descriptor_s &td, int from, int to, TTCN_Buffer &buf)

## Detailed Description

### template<typename TPDU>
class per_code< TPDU >

Declare asn1c class.

This class This class provides the interface for all ASN.1 PER codecs.

Remarks
  This class uses asn1c external tool

## Member Function Documentation

## ◆ _decode()

template<class TPDU>

int per_code< TPDU >::_decode | ( | const TTCN_Typedescriptor_t & | ttcn,
|  | const asn_TYPE_descriptor_s & | td,
|  | const BITSTRING & | p_data,
|  | TPDU & | msg
| ) |  |
| protected

## ◆ _encode()

template<class TPDU>

int per_code< TPDU >::_encode | ( | const TTCN_Typedescriptor_t & | ttcn,
|  | const asn_TYPE_descriptor_s & | td,
|  | const TPDU & | msg,
|  | BITSTRING & | p_data
| ) |  |
| protected

## ◆ decode()

template<typename TPDU>

int per_code< TPDU >::decode | ( | const BITSTRING & | p_bitstring,
|  | TPDU & | p_message
| ) |  |
| pure virtual

Decode ASN.1 PER message into TITAN message.

Parameters

  [in] | p_bitstring | The network message in bit string format to decode
  [out] | p_message | The PDU message

Implemented in DENMPDUCodec, CAMPDUCodec, IVIMPDUCodec, MapemPDUCodec, SpatemPDUCodec, SremPDUCodec, and SsemPDUCodec.

## ◆ encode()

template<typename TPDU>

int per_code< TPDU >::encode | ( | const TPDU & | p_message,
|  | BITSTRING & | p_bitstring
| ) |  |
| pure virtual

Encode TITAN message into ASN.1 PER message.

Parameters

  [in] | p_message | The PDU message to encode
  [out] | p_bitstring | The encoded PDU message in bit string format

Implemented in DENMPDUCodec, CAMPDUCodec, IVIMPDUCodec, MapemPDUCodec, SpatemPDUCodec, SremPDUCodec, and SsemPDUCodec.

The documentation for this class was generated from the following files:

- /home/vagrant/TriesAndDelete/etsi_its/framework/include/per_code.hh
- /home/vagrant/TriesAndDelete/etsi_its/framework/include/per_code.t.hh